#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <stdexcept>

using namespace std;

void readIntegerFile(const string& fileName, vector<int>& dest)
  throw (invalid_argument, runtime_error)
{
  ifstream istr;
  int temp;

  istr.open(fileName.c_str());
  if (istr.fail()) {
   // Nie udao si otworzy pliku - zgo wyjtek.
    string error = "Nie udao si otworzy pliku " + fileName;
    throw invalid_argument(error);
  }

  // Odczytuje kolejne wartoci cakowite i dodaje je do wektora.
  while (istr >> temp) {
    dest.push_back(temp);
  }

  if (istr.eof()) {
    // Osignlimy koniec pliku.
    istr.close();
  } else {
    // Inny bd. Zgo wyjtek.
    istr.close();
    string error = "Bd odczytu pliku " + fileName;
    throw runtime_error(error);
  }
}

int main(int argc, char** argv)
{
  vector<int> myInts;
  const string fileName = "IntegerFile.txt";

  try {
    readIntegerFile(fileName, myInts);
  } catch (const exception& e) {
    cerr << e.what() << endl;
    exit (1);
  }

  for (size_t i = 0; i < myInts.size(); i++) {
    cout << myInts[i] << " ";
  }
  cout << endl;

  return (0);
}
